## Analysis
  * Compression Analysis
    * [psnr](https://github.com/TheAlgorithms/Python/blob/master/analysis/compression_analysis/psnr.py)
## Arithmetic Analysis
  * [bisection](https://github.com/TheAlgorithms/Python/blob/master/arithmetic_analysis/bisection.py)
  * [intersection](https://github.com/TheAlgorithms/Python/blob/master/arithmetic_analysis/intersection.py)
  * [lu decomposition](https://github.com/TheAlgorithms/Python/blob/master/arithmetic_analysis/lu_decomposition.py)
  * [newton method](https://github.com/TheAlgorithms/Python/blob/master/arithmetic_analysis/newton_method.py)
  * [newton raphson method](https://github.com/TheAlgorithms/Python/blob/master/arithmetic_analysis/newton_raphson_method.py)
## Binary Tree
  * [basic binary tree](https://github.com/TheAlgorithms/Python/blob/master/binary_tree/basic_binary_tree.py)
## Boolean Algebra
  * [quine mc cluskey](https://github.com/TheAlgorithms/Python/blob/master/boolean_algebra/quine_mc_cluskey.py)
## Ciphers
  * [affine cipher](https://github.com/TheAlgorithms/Python/blob/master/ciphers/affine_cipher.py)
  * [Atbash](https://github.com/TheAlgorithms/Python/blob/master/ciphers/Atbash.py)
  * [base16](https://github.com/TheAlgorithms/Python/blob/master/ciphers/base16.py)
  * [base32](https://github.com/TheAlgorithms/Python/blob/master/ciphers/base32.py)
  * [base64 cipher](https://github.com/TheAlgorithms/Python/blob/master/ciphers/base64_cipher.py)
  * [base85](https://github.com/TheAlgorithms/Python/blob/master/ciphers/base85.py)
  * [brute force caesar cipher](https://github.com/TheAlgorithms/Python/blob/master/ciphers/brute_force_caesar_cipher.py)
  * [caesar cipher](https://github.com/TheAlgorithms/Python/blob/master/ciphers/caesar_cipher.py)
  * [cryptomath module](https://github.com/TheAlgorithms/Python/blob/master/ciphers/cryptomath_module.py)
  * [elgamal key generator](https://github.com/TheAlgorithms/Python/blob/master/ciphers/elgamal_key_generator.py)
  * [hill cipher](https://github.com/TheAlgorithms/Python/blob/master/ciphers/hill_cipher.py)
  * [morse Code implementation](https://github.com/TheAlgorithms/Python/blob/master/ciphers/morse_Code_implementation.py)
  * [onepad cipher](https://github.com/TheAlgorithms/Python/blob/master/ciphers/onepad_cipher.py)
  * [playfair cipher](https://github.com/TheAlgorithms/Python/blob/master/ciphers/playfair_cipher.py)
  * [prehistoric men](https://github.com/TheAlgorithms/Python/blob/master/ciphers/prehistoric_men.txt)
  * [rabin miller](https://github.com/TheAlgorithms/Python/blob/master/ciphers/rabin_miller.py)
  * [rot13](https://github.com/TheAlgorithms/Python/blob/master/ciphers/rot13.py)
  * [rsa cipher](https://github.com/TheAlgorithms/Python/blob/master/ciphers/rsa_cipher.py)
  * [rsa key generator](https://github.com/TheAlgorithms/Python/blob/master/ciphers/rsa_key_generator.py)
  * [simple substitution cipher](https://github.com/TheAlgorithms/Python/blob/master/ciphers/simple_substitution_cipher.py)
  * [trafid cipher](https://github.com/TheAlgorithms/Python/blob/master/ciphers/trafid_cipher.py)
  * [transposition cipher](https://github.com/TheAlgorithms/Python/blob/master/ciphers/transposition_cipher.py)
  * [transposition cipher encrypt decrypt file](https://github.com/TheAlgorithms/Python/blob/master/ciphers/transposition_cipher_encrypt_decrypt_file.py)
  * [vigenere cipher](https://github.com/TheAlgorithms/Python/blob/master/ciphers/vigenere_cipher.py)
  * [xor cipher](https://github.com/TheAlgorithms/Python/blob/master/ciphers/xor_cipher.py)
## Compression
  * [huffman](https://github.com/TheAlgorithms/Python/blob/master/compression/huffman.py)
## Data Structures
  * [arrays](https://github.com/TheAlgorithms/Python/blob/master/data_structures/arrays.py)
  * [avl](https://github.com/TheAlgorithms/Python/blob/master/data_structures/avl.py)
  * [LCA](https://github.com/TheAlgorithms/Python/blob/master/data_structures/LCA.py)
  * Binary Tree
    * [AVL tree](https://github.com/TheAlgorithms/Python/blob/master/data_structures/binary%20tree/AVL_tree.py)
    * [binary search tree](https://github.com/TheAlgorithms/Python/blob/master/data_structures/binary%20tree/binary_search_tree.py)
    * [fenwick tree](https://github.com/TheAlgorithms/Python/blob/master/data_structures/binary%20tree/fenwick_tree.py)
    * [lazy segment tree](https://github.com/TheAlgorithms/Python/blob/master/data_structures/binary%20tree/lazy_segment_tree.py)
    * [segment tree](https://github.com/TheAlgorithms/Python/blob/master/data_structures/binary%20tree/segment_tree.py)
    * [treap](https://github.com/TheAlgorithms/Python/blob/master/data_structures/binary%20tree/treap.py)
  * Hashing
    * [double hash](https://github.com/TheAlgorithms/Python/blob/master/data_structures/hashing/double_hash.py)
    * [hash table](https://github.com/TheAlgorithms/Python/blob/master/data_structures/hashing/hash_table.py)
    * [hash table with linked list](https://github.com/TheAlgorithms/Python/blob/master/data_structures/hashing/hash_table_with_linked_list.py)
    * [quadratic probing](https://github.com/TheAlgorithms/Python/blob/master/data_structures/hashing/quadratic_probing.py)
    * Number Theory
      * [prime numbers](https://github.com/TheAlgorithms/Python/blob/master/data_structures/hashing/number_theory/prime_numbers.py)
  * Heap
    * [heap](https://github.com/TheAlgorithms/Python/blob/master/data_structures/heap/heap.py)
  * Linked List
    * [doubly linked list](https://github.com/TheAlgorithms/Python/blob/master/data_structures/linked_list/doubly_linked_list.py)
    * [is Palindrome](https://github.com/TheAlgorithms/Python/blob/master/data_structures/linked_list/is_Palindrome.py)
    * [singly linked list](https://github.com/TheAlgorithms/Python/blob/master/data_structures/linked_list/singly_linked_list.py)
    * [swapNodes](https://github.com/TheAlgorithms/Python/blob/master/data_structures/linked_list/swapNodes.py)
  * Queue
    * [double ended queue](https://github.com/TheAlgorithms/Python/blob/master/data_structures/queue/double_ended_queue.py)
    * [queue on list](https://github.com/TheAlgorithms/Python/blob/master/data_structures/queue/queue_on_list.py)
    * [queue on pseudo stack](https://github.com/TheAlgorithms/Python/blob/master/data_structures/queue/queue_on_pseudo_stack.py)
  * Stacks
    * [balanced parentheses](https://github.com/TheAlgorithms/Python/blob/master/data_structures/stacks/balanced_parentheses.py)
    * [infix to postfix conversion](https://github.com/TheAlgorithms/Python/blob/master/data_structures/stacks/infix_to_postfix_conversion.py)
    * [infix to prefix conversion](https://github.com/TheAlgorithms/Python/blob/master/data_structures/stacks/infix_to_prefix_conversion.py)
    * [next](https://github.com/TheAlgorithms/Python/blob/master/data_structures/stacks/next.py)
    * [postfix evaluation](https://github.com/TheAlgorithms/Python/blob/master/data_structures/stacks/postfix_evaluation.py)
    * [stack](https://github.com/TheAlgorithms/Python/blob/master/data_structures/stacks/stack.py)
    * [stock span problem](https://github.com/TheAlgorithms/Python/blob/master/data_structures/stacks/stock_span_problem.py)
  * Trie
    * [trie](https://github.com/TheAlgorithms/Python/blob/master/data_structures/trie/trie.py)
  * Union Find
    * [tests union find](https://github.com/TheAlgorithms/Python/blob/master/data_structures/union_find/tests_union_find.py)
    * [union find](https://github.com/TheAlgorithms/Python/blob/master/data_structures/union_find/union_find.py)
## Digital Image Processing
  * Filters
    * [median filter](https://github.com/TheAlgorithms/Python/blob/master/digital_image_processing/filters/median_filter.py)
## Dynamic Programming
  * [abbreviation](https://github.com/TheAlgorithms/Python/blob/master/dynamic_programming/abbreviation.py)
  * [bitmask](https://github.com/TheAlgorithms/Python/blob/master/dynamic_programming/bitmask.py)
  * [coin change](https://github.com/TheAlgorithms/Python/blob/master/dynamic_programming/coin_change.py)
  * [edit distance](https://github.com/TheAlgorithms/Python/blob/master/dynamic_programming/edit_distance.py)
  * [fast fibonacci](https://github.com/TheAlgorithms/Python/blob/master/dynamic_programming/fast_fibonacci.py)
  * [fibonacci](https://github.com/TheAlgorithms/Python/blob/master/dynamic_programming/fibonacci.py)
  * [floyd warshall](https://github.com/TheAlgorithms/Python/blob/master/dynamic_programming/floyd_warshall.py)
  * [Fractional Knapsack](https://github.com/TheAlgorithms/Python/blob/master/dynamic_programming/Fractional_Knapsack.py)
  * [integer partition](https://github.com/TheAlgorithms/Python/blob/master/dynamic_programming/integer_partition.py)
  * [k means clustering tensorflow](https://github.com/TheAlgorithms/Python/blob/master/dynamic_programming/k_means_clustering_tensorflow.py)
  * [knapsack](https://github.com/TheAlgorithms/Python/blob/master/dynamic_programming/knapsack.py)
  * [longest common subsequence](https://github.com/TheAlgorithms/Python/blob/master/dynamic_programming/longest_common_subsequence.py)
  * [longest increasing subsequence](https://github.com/TheAlgorithms/Python/blob/master/dynamic_programming/longest_increasing_subsequence.py)
  * [longest increasing subsequence O(nlogn)](https://github.com/TheAlgorithms/Python/blob/master/dynamic_programming/longest_increasing_subsequence_O(nlogn).py)
  * [longest sub array](https://github.com/TheAlgorithms/Python/blob/master/dynamic_programming/longest_sub_array.py)
  * [matrix chain order](https://github.com/TheAlgorithms/Python/blob/master/dynamic_programming/matrix_chain_order.py)
  * [max sub array](https://github.com/TheAlgorithms/Python/blob/master/dynamic_programming/max_sub_array.py)
  * [minimum partition](https://github.com/TheAlgorithms/Python/blob/master/dynamic_programming/minimum_partition.py)
  * [rod cutting](https://github.com/TheAlgorithms/Python/blob/master/dynamic_programming/rod_cutting.py)
  * [subset generation](https://github.com/TheAlgorithms/Python/blob/master/dynamic_programming/subset_generation.py)
## File Transfer Protocol
  * [ftp client server](https://github.com/TheAlgorithms/Python/blob/master/file_transfer_protocol/ftp_client_server.py)
  * [ftp send receive](https://github.com/TheAlgorithms/Python/blob/master/file_transfer_protocol/ftp_send_receive.py)
## Graphs
  * [a star](https://github.com/TheAlgorithms/Python/blob/master/graphs/a_star.py)
  * [articulation points](https://github.com/TheAlgorithms/Python/blob/master/graphs/articulation_points.py)
  * [basic graphs](https://github.com/TheAlgorithms/Python/blob/master/graphs/basic_graphs.py)
  * [bellman ford](https://github.com/TheAlgorithms/Python/blob/master/graphs/bellman_ford.py)
  * [BFS](https://github.com/TheAlgorithms/Python/blob/master/graphs/BFS.py)
  * [bfs shortest path](https://github.com/TheAlgorithms/Python/blob/master/graphs/bfs_shortest_path.py)
  * [breadth first search](https://github.com/TheAlgorithms/Python/blob/master/graphs/breadth_first_search.py)
  * [check bipartite graph bfs](https://github.com/TheAlgorithms/Python/blob/master/graphs/check_bipartite_graph_bfs.py)
  * [check bipartite graph dfs](https://github.com/TheAlgorithms/Python/blob/master/graphs/check_bipartite_graph_dfs.py)
  * [depth first search](https://github.com/TheAlgorithms/Python/blob/master/graphs/depth_first_search.py)
  * [DFS](https://github.com/TheAlgorithms/Python/blob/master/graphs/DFS.py)
  * [dijkstra](https://github.com/TheAlgorithms/Python/blob/master/graphs/dijkstra.py)
  * [dijkstra 2](https://github.com/TheAlgorithms/Python/blob/master/graphs/dijkstra_2.py)
  * [dijkstra algorithm](https://github.com/TheAlgorithms/Python/blob/master/graphs/dijkstra_algorithm.py)
  * [Directed and Undirected (Weighted) Graph](https://github.com/TheAlgorithms/Python/blob/master/graphs/Directed_and_Undirected_(Weighted)_Graph.py)
  * [edmonds karp multiple source and sink](https://github.com/TheAlgorithms/Python/blob/master/graphs/edmonds_karp_multiple_source_and_sink.py)
  * [Eulerian path and circuit for undirected graph](https://github.com/TheAlgorithms/Python/blob/master/graphs/Eulerian_path_and_circuit_for_undirected_graph.py)
  * [even tree](https://github.com/TheAlgorithms/Python/blob/master/graphs/even_tree.py)
  * [finding bridges](https://github.com/TheAlgorithms/Python/blob/master/graphs/finding_bridges.py)
  * [floyd warshall](https://github.com/TheAlgorithms/Python/blob/master/graphs/floyd_warshall.py)
  * [graph list](https://github.com/TheAlgorithms/Python/blob/master/graphs/graph_list.py)
  * [graph matrix](https://github.com/TheAlgorithms/Python/blob/master/graphs/graph_matrix.py)
  * [kahns algorithm long](https://github.com/TheAlgorithms/Python/blob/master/graphs/kahns_algorithm_long.py)
  * [kahns algorithm topo](https://github.com/TheAlgorithms/Python/blob/master/graphs/kahns_algorithm_topo.py)
  * [minimum spanning tree kruskal](https://github.com/TheAlgorithms/Python/blob/master/graphs/minimum_spanning_tree_kruskal.py)
  * [minimum spanning tree prims](https://github.com/TheAlgorithms/Python/blob/master/graphs/minimum_spanning_tree_prims.py)
  * [multi hueristic astar](https://github.com/TheAlgorithms/Python/blob/master/graphs/multi_hueristic_astar.py)
  * [page rank](https://github.com/TheAlgorithms/Python/blob/master/graphs/page_rank.py)
  * [prim](https://github.com/TheAlgorithms/Python/blob/master/graphs/prim.py)
  * [scc kosaraju](https://github.com/TheAlgorithms/Python/blob/master/graphs/scc_kosaraju.py)
  * [tarjans scc](https://github.com/TheAlgorithms/Python/blob/master/graphs/tarjans_scc.py)
## Hashes
  * [chaos machine](https://github.com/TheAlgorithms/Python/blob/master/hashes/chaos_machine.py)
  * [md5](https://github.com/TheAlgorithms/Python/blob/master/hashes/md5.py)
  * [sha1](https://github.com/TheAlgorithms/Python/blob/master/hashes/sha1.py)
## Linear Algebra Python
  * Src
    * [lib](https://github.com/TheAlgorithms/Python/blob/master/linear_algebra_python/src/lib.py)
    * [tests](https://github.com/TheAlgorithms/Python/blob/master/linear_algebra_python/src/tests.py)
## Machine Learning
  * [decision tree](https://github.com/TheAlgorithms/Python/blob/master/machine_learning/decision_tree.py)
  * [gradient descent](https://github.com/TheAlgorithms/Python/blob/master/machine_learning/gradient_descent.py)
  * [k means clust](https://github.com/TheAlgorithms/Python/blob/master/machine_learning/k_means_clust.py)
  * [linear regression](https://github.com/TheAlgorithms/Python/blob/master/machine_learning/linear_regression.py)
  * [logistic regression](https://github.com/TheAlgorithms/Python/blob/master/machine_learning/logistic_regression.py)
  * [perceptron](https://github.com/TheAlgorithms/Python/blob/master/machine_learning/perceptron.py)
  * [scoring functions](https://github.com/TheAlgorithms/Python/blob/master/machine_learning/scoring_functions.py)
  * Random Forest Classification
    * [random forest classification](https://github.com/TheAlgorithms/Python/blob/master/machine_learning/Random%20Forest%20Classification/random_forest_classification.py)
    * [Social Network Ads](https://github.com/TheAlgorithms/Python/blob/master/machine_learning/Random%20Forest%20Classification/Social_Network_Ads.csv)
  * Random Forest Regression
    * [Position Salaries](https://github.com/TheAlgorithms/Python/blob/master/machine_learning/Random%20Forest%20Regression/Position_Salaries.csv)
    * [random forest regression](https://github.com/TheAlgorithms/Python/blob/master/machine_learning/Random%20Forest%20Regression/random_forest_regression.py)
## Maths
  * [3n+1](https://github.com/TheAlgorithms/Python/blob/master/maths/3n+1.py)
  * [abs](https://github.com/TheAlgorithms/Python/blob/master/maths/abs.py)
  * [abs Max](https://github.com/TheAlgorithms/Python/blob/master/maths/abs_Max.py)
  * [abs Min](https://github.com/TheAlgorithms/Python/blob/master/maths/abs_Min.py)
  * [average](https://github.com/TheAlgorithms/Python/blob/master/maths/average.py)
  * [basic maths](https://github.com/TheAlgorithms/Python/blob/master/maths/basic_maths.py)
  * [Binary Exponentiation](https://github.com/TheAlgorithms/Python/blob/master/maths/Binary_Exponentiation.py)
  * [extended euclidean algorithm](https://github.com/TheAlgorithms/Python/blob/master/maths/extended_euclidean_algorithm.py)
  * [factorial python](https://github.com/TheAlgorithms/Python/blob/master/maths/factorial_python.py)
  * [factorial recursive](https://github.com/TheAlgorithms/Python/blob/master/maths/factorial_recursive.py)
  * [fermat little theorem](https://github.com/TheAlgorithms/Python/blob/master/maths/fermat_little_theorem.py)
  * [fibonacci](https://github.com/TheAlgorithms/Python/blob/master/maths/fibonacci.py)
  * [fibonacci sequence recursion](https://github.com/TheAlgorithms/Python/blob/master/maths/fibonacci_sequence_recursion.py)
  * [find lcm](https://github.com/TheAlgorithms/Python/blob/master/maths/find_lcm.py)
  * [Find Max](https://github.com/TheAlgorithms/Python/blob/master/maths/Find_Max.py)
  * [Find Min](https://github.com/TheAlgorithms/Python/blob/master/maths/Find_Min.py)
  * [greater common divisor](https://github.com/TheAlgorithms/Python/blob/master/maths/greater_common_divisor.py)
  * [Hanoi](https://github.com/TheAlgorithms/Python/blob/master/maths/Hanoi.py)
  * [lucasSeries](https://github.com/TheAlgorithms/Python/blob/master/maths/lucasSeries.py)
  * [modular exponential](https://github.com/TheAlgorithms/Python/blob/master/maths/modular_exponential.py)
  * [newton raphson](https://github.com/TheAlgorithms/Python/blob/master/maths/newton_raphson.py)
  * [Prime Check](https://github.com/TheAlgorithms/Python/blob/master/maths/Prime_Check.py)
  * [segmented sieve](https://github.com/TheAlgorithms/Python/blob/master/maths/segmented_sieve.py)
  * [sieve of eratosthenes](https://github.com/TheAlgorithms/Python/blob/master/maths/sieve_of_eratosthenes.py)
  * [simpson rule](https://github.com/TheAlgorithms/Python/blob/master/maths/simpson_rule.py)
  * [trapezoidal rule](https://github.com/TheAlgorithms/Python/blob/master/maths/trapezoidal_rule.py)
  * Tests
    * [test fibonacci](https://github.com/TheAlgorithms/Python/blob/master/maths/tests/test_fibonacci.py)
## Matrix
  * [matrix multiplication addition](https://github.com/TheAlgorithms/Python/blob/master/matrix/matrix_multiplication_addition.py)
  * [searching in sorted matrix](https://github.com/TheAlgorithms/Python/blob/master/matrix/searching_in_sorted_matrix.py)
## Networking Flow
  * [ford fulkerson](https://github.com/TheAlgorithms/Python/blob/master/networking_flow/ford_fulkerson.py)
  * [minimum cut](https://github.com/TheAlgorithms/Python/blob/master/networking_flow/minimum_cut.py)
## Neural Network
  * [bpnn](https://github.com/TheAlgorithms/Python/blob/master/neural_network/bpnn.py)
  * [convolution neural network](https://github.com/TheAlgorithms/Python/blob/master/neural_network/convolution_neural_network.py)
  * [perceptron](https://github.com/TheAlgorithms/Python/blob/master/neural_network/perceptron.py)
## Other
  * [anagrams](https://github.com/TheAlgorithms/Python/blob/master/other/anagrams.py)
  * [binary exponentiation](https://github.com/TheAlgorithms/Python/blob/master/other/binary_exponentiation.py)
  * [binary exponentiation 2](https://github.com/TheAlgorithms/Python/blob/master/other/binary_exponentiation_2.py)
  * [detecting english programmatically](https://github.com/TheAlgorithms/Python/blob/master/other/detecting_english_programmatically.py)
  * [dictionary](https://github.com/TheAlgorithms/Python/blob/master/other/dictionary.txt)
  * [euclidean gcd](https://github.com/TheAlgorithms/Python/blob/master/other/euclidean_gcd.py)
  * [finding Primes](https://github.com/TheAlgorithms/Python/blob/master/other/finding_Primes.py)
  * [fischer yates shuffle](https://github.com/TheAlgorithms/Python/blob/master/other/fischer_yates_shuffle.py)
  * [frequency finder](https://github.com/TheAlgorithms/Python/blob/master/other/frequency_finder.py)
  * [linear congruential generator](https://github.com/TheAlgorithms/Python/blob/master/other/linear_congruential_generator.py)
  * [n queens](https://github.com/TheAlgorithms/Python/blob/master/other/n_queens.py)
  * [nested brackets](https://github.com/TheAlgorithms/Python/blob/master/other/nested_brackets.py)
  * [palindrome](https://github.com/TheAlgorithms/Python/blob/master/other/palindrome.py)
  * [password generator](https://github.com/TheAlgorithms/Python/blob/master/other/password_generator.py)
  * [primelib](https://github.com/TheAlgorithms/Python/blob/master/other/primelib.py)
  * [sierpinski triangle](https://github.com/TheAlgorithms/Python/blob/master/other/sierpinski_triangle.py)
  * [tower of hanoi](https://github.com/TheAlgorithms/Python/blob/master/other/tower_of_hanoi.py)
  * [two sum](https://github.com/TheAlgorithms/Python/blob/master/other/two_sum.py)
  * [word patterns](https://github.com/TheAlgorithms/Python/blob/master/other/word_patterns.py)
  * [words](https://github.com/TheAlgorithms/Python/blob/master/other/words)
  * Game Of Life
    * [game o life](https://github.com/TheAlgorithms/Python/blob/master/other/game_of_life/game_o_life.py)
    * [sample](https://github.com/TheAlgorithms/Python/blob/master/other/game_of_life/sample.gif)
## Project Euler
  * Problem 01
    * [sol1](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_01/sol1.py)
    * [sol2](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_01/sol2.py)
    * [sol3](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_01/sol3.py)
    * [sol4](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_01/sol4.py)
    * [sol5](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_01/sol5.py)
    * [sol6](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_01/sol6.py)
  * Problem 02
    * [sol1](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_02/sol1.py)
    * [sol2](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_02/sol2.py)
    * [sol3](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_02/sol3.py)
    * [sol4](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_02/sol4.py)
  * Problem 03
    * [sol1](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_03/sol1.py)
    * [sol2](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_03/sol2.py)
  * Problem 04
    * [sol1](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_04/sol1.py)
    * [sol2](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_04/sol2.py)
  * Problem 05
    * [sol1](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_05/sol1.py)
    * [sol2](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_05/sol2.py)
  * Problem 06
    * [sol1](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_06/sol1.py)
    * [sol2](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_06/sol2.py)
    * [sol3](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_06/sol3.py)
  * Problem 07
    * [sol1](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_07/sol1.py)
    * [sol2](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_07/sol2.py)
    * [sol3](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_07/sol3.py)
  * Problem 08
    * [sol1](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_08/sol1.py)
    * [sol2](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_08/sol2.py)
  * Problem 09
    * [sol1](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_09/sol1.py)
    * [sol2](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_09/sol2.py)
    * [sol3](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_09/sol3.py)
  * Problem 10
    * [sol1](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_10/sol1.py)
    * [sol2](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_10/sol2.py)
  * Problem 11
    * [grid](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_11/grid.txt)
    * [sol1](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_11/sol1.py)
    * [sol2](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_11/sol2.py)
  * Problem 12
    * [sol1](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_12/sol1.py)
    * [sol2](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_12/sol2.py)
  * Problem 13
    * [sol1](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_13/sol1.py)
  * Problem 14
    * [sol1](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_14/sol1.py)
    * [sol2](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_14/sol2.py)
  * Problem 15
    * [sol1](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_15/sol1.py)
  * Problem 16
    * [sol1](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_16/sol1.py)
  * Problem 17
    * [sol1](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_17/sol1.py)
  * Problem 19
    * [sol1](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_19/sol1.py)
  * Problem 20
    * [sol1](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_20/sol1.py)
    * [sol2](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_20/sol2.py)
  * Problem 21
    * [sol1](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_21/sol1.py)
  * Problem 22
    * [p022 names](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_22/p022_names.txt)
    * [sol1](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_22/sol1.py)
    * [sol2](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_22/sol2.py)
  * Problem 24
    * [sol1](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_24/sol1.py)
  * Problem 25
    * [sol1](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_25/sol1.py)
    * [sol2](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_25/sol2.py)
  * Problem 28
    * [sol1](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_28/sol1.py)
  * Problem 29
    * [solution](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_29/solution.py)
  * Problem 31
    * [sol1](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_31/sol1.py)
  * Problem 36
    * [sol1](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_36/sol1.py)
  * Problem 40
    * [sol1](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_40/sol1.py)
  * Problem 48
    * [sol1](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_48/sol1.py)
  * Problem 52
    * [sol1](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_52/sol1.py)
  * Problem 53
    * [sol1](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_53/sol1.py)
  * Problem 76
    * [sol1](https://github.com/TheAlgorithms/Python/blob/master/project_euler/problem_76/sol1.py)
## Searches
  * [binary search](https://github.com/TheAlgorithms/Python/blob/master/searches/binary_search.py)
  * [interpolation search](https://github.com/TheAlgorithms/Python/blob/master/searches/interpolation_search.py)
  * [jump search](https://github.com/TheAlgorithms/Python/blob/master/searches/jump_search.py)
  * [linear search](https://github.com/TheAlgorithms/Python/blob/master/searches/linear_search.py)
  * [quick select](https://github.com/TheAlgorithms/Python/blob/master/searches/quick_select.py)
  * [sentinel linear search](https://github.com/TheAlgorithms/Python/blob/master/searches/sentinel_linear_search.py)
  * [tabu search](https://github.com/TheAlgorithms/Python/blob/master/searches/tabu_search.py)
  * [tabu test data](https://github.com/TheAlgorithms/Python/blob/master/searches/tabu_test_data.txt)
  * [ternary search](https://github.com/TheAlgorithms/Python/blob/master/searches/ternary_search.py)
  * [test interpolation search](https://github.com/TheAlgorithms/Python/blob/master/searches/test_interpolation_search.py)
  * [test tabu search](https://github.com/TheAlgorithms/Python/blob/master/searches/test_tabu_search.py)
## Simple Client
  * [client](https://github.com/TheAlgorithms/Python/blob/master/simple_client/client.py)
  * [server](https://github.com/TheAlgorithms/Python/blob/master/simple_client/server.py)
## Sorts
  * [Bitonic Sort](https://github.com/TheAlgorithms/Python/blob/master/sorts/Bitonic_Sort.py)
  * [bogo sort](https://github.com/TheAlgorithms/Python/blob/master/sorts/bogo_sort.py)
  * [bubble sort](https://github.com/TheAlgorithms/Python/blob/master/sorts/bubble_sort.py)
  * [bucket sort](https://github.com/TheAlgorithms/Python/blob/master/sorts/bucket_sort.py)
  * [cocktail shaker sort](https://github.com/TheAlgorithms/Python/blob/master/sorts/cocktail_shaker_sort.py)
  * [comb sort](https://github.com/TheAlgorithms/Python/blob/master/sorts/comb_sort.py)
  * [counting sort](https://github.com/TheAlgorithms/Python/blob/master/sorts/counting_sort.py)
  * [cycle sort](https://github.com/TheAlgorithms/Python/blob/master/sorts/cycle_sort.py)
  * [external sort](https://github.com/TheAlgorithms/Python/blob/master/sorts/external_sort.py)
  * [gnome sort](https://github.com/TheAlgorithms/Python/blob/master/sorts/gnome_sort.py)
  * [heap sort](https://github.com/TheAlgorithms/Python/blob/master/sorts/heap_sort.py)
  * [insertion sort](https://github.com/TheAlgorithms/Python/blob/master/sorts/insertion_sort.py)
  * [merge sort](https://github.com/TheAlgorithms/Python/blob/master/sorts/merge_sort.py)
  * [merge sort fastest](https://github.com/TheAlgorithms/Python/blob/master/sorts/merge_sort_fastest.py)
  * [Odd-Even transposition parallel](https://github.com/TheAlgorithms/Python/blob/master/sorts/Odd-Even_transposition_parallel.py)
  * [Odd-Even transposition single-threaded](https://github.com/TheAlgorithms/Python/blob/master/sorts/Odd-Even_transposition_single-threaded.py)
  * [pancake sort](https://github.com/TheAlgorithms/Python/blob/master/sorts/pancake_sort.py)
  * [pigeon sort](https://github.com/TheAlgorithms/Python/blob/master/sorts/pigeon_sort.py)
  * [quick sort](https://github.com/TheAlgorithms/Python/blob/master/sorts/quick_sort.py)
  * [quick sort 3 partition](https://github.com/TheAlgorithms/Python/blob/master/sorts/quick_sort_3_partition.py)
  * [radix sort](https://github.com/TheAlgorithms/Python/blob/master/sorts/radix_sort.py)
  * [random normal distribution quicksort](https://github.com/TheAlgorithms/Python/blob/master/sorts/random_normal_distribution_quicksort.py)
  * [random pivot quick sort](https://github.com/TheAlgorithms/Python/blob/master/sorts/random_pivot_quick_sort.py)
  * [selection sort](https://github.com/TheAlgorithms/Python/blob/master/sorts/selection_sort.py)
  * [shell sort](https://github.com/TheAlgorithms/Python/blob/master/sorts/shell_sort.py)
  * [tests](https://github.com/TheAlgorithms/Python/blob/master/sorts/tests.py)
  * [tim sort](https://github.com/TheAlgorithms/Python/blob/master/sorts/tim_sort.py)
  * [topological sort](https://github.com/TheAlgorithms/Python/blob/master/sorts/topological_sort.py)
  * [tree sort](https://github.com/TheAlgorithms/Python/blob/master/sorts/tree_sort.py)
  * [wiggle sort](https://github.com/TheAlgorithms/Python/blob/master/sorts/wiggle_sort.py)
## Strings
  * [knuth morris pratt](https://github.com/TheAlgorithms/Python/blob/master/strings/knuth_morris_pratt.py)
  * [levenshtein distance](https://github.com/TheAlgorithms/Python/blob/master/strings/levenshtein_distance.py)
  * [manacher](https://github.com/TheAlgorithms/Python/blob/master/strings/manacher.py)
  * [min cost string conversion](https://github.com/TheAlgorithms/Python/blob/master/strings/min_cost_string_conversion.py)
  * [naive String Search](https://github.com/TheAlgorithms/Python/blob/master/strings/naive_String_Search.py)
  * [rabin karp](https://github.com/TheAlgorithms/Python/blob/master/strings/rabin_karp.py)
## Traversals
  * [binary tree traversals](https://github.com/TheAlgorithms/Python/blob/master/traversals/binary_tree_traversals.py)
